﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Finances.Entities
{
    [Api(Description = "分析")]
    public class Analysis
    {
        public decimal Amount { get; set; }

        public decimal AmountSettlement { get; set; }

        public decimal AmountInvoice { get; set; }

        public decimal AmountPayment { get; set; }

        public decimal AmountUnpaid { get; set; }

        public decimal AmountOffset { get; set; }

        public int Quantity { get; set; }

        public int QuantityInvoice { get; set; }

        public int QuantitySettlement { get; set; }

        public int QuantityPayment { get; set; }

        public int QuantityUnpaid { get; set; }

        public int QuantityOffset { get; set; }

        public AnalysisType Type { get; set; }

        public DateTime BeginTime { get; set; }

        public DateTime EndTime { get; set; }

        public string Summary { get; set; }
    }

    /// <summary>
    /// 分析类型,默认按月,支持: 年,月,日,季度
    /// </summary>
    public enum AnalysisType
    {
        Unsupported = 0,
        Month,
        Day,
        Season,
        Year
    }
}
