﻿using Kivii.Finances.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Finances
{
    public static class BillExtension
    {
        public static BillDetail Offset(this BillDetail billDetail,string remark)
        {
            billDetail.ThrowIfNull("账单明细不能为空!");
            (billDetail.OffsetKvid != Guid.Empty).ThrowIfTrue("当前账单明细已作废!无需重复操作!");

            #region payment冲账
            var newBillDetailKvid = Guid.NewGuid();
            billDetail.OffsetKvid = newBillDetailKvid;
            billDetail.AddOnlyProperties(o => o.OffsetKvid);
            billDetail.Remark = $"{remark}";
            billDetail.AddOnlyProperties(o => o.Remark);

            //新建一个和原来一样的
            var offsetBillDetail = new BillDetail();
            offsetBillDetail.PopulateWith(billDetail);
            offsetBillDetail.OffsetKvid = billDetail.Kvid;//新的冲帐关联用原来的Kvid
            offsetBillDetail.Kvid = newBillDetailKvid;
            offsetBillDetail.SerialNumber = billDetail.SerialNumber.IsNullOrEmpty() ? "" : ("-" + billDetail.SerialNumber);
            offsetBillDetail.Remark = $"{remark}";
            offsetBillDetail.Amount = 0 - offsetBillDetail.Amount;//反向值
            #endregion

            return offsetBillDetail;
        }
    }
}
