﻿using Kivii.Finances.Entities;
using Kivii.Linq;
using Kivii.Web;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Finances.Transforms
{

    [Api(Description = "发票作废")]
    [RequiresAnyRole(SystemRoles.Everyone)]
    public class InvoiceOffset:RestfulExecution<Invoice>
    {
        public Guid Kvid { get; set; }

        public string Remark { get; set; }

        public override object OnExecution(IRequest req, IResponse res)
        {
            Kvid.ThrowIfEmpty("请传入要冲销的发票Kvid!");
            var conn = KiviiContext.GetOpenedDbConnection<Invoice>();
            var invoice = conn.SingleById<Invoice>(Kvid);
            invoice.ThrowIfNull("未找到对应发票!");
            invoice.BizKvid.ThrowIfNotEmpty("发票已关联业务! 请先解除关联!");
            invoice.OffsetKvid.ThrowIfNotEmpty("发票已作废!");
            var apply = conn.SingleById<InvoiceApply>(invoice.ApplyKvid);
             
            return base.OnExecution(req, res);
        }
    }

    [Api(Description = "作废撤回")]
    [RequiresAnyRole(SystemRoles.Everyone)]
    public class InvoiceOffsetCancel : RestfulExecution<Invoice>
    {
    }

    [Api(Description = "发票红冲")]
    [RequiresAnyRole(SystemRoles.Everyone)]
    public class InvoiceDeficit : RestfulExecution<Invoice>
    {

    }

    [Api(Description = "红冲撤回")]
    [RequiresAnyRole(SystemRoles.Everyone)]
    public class InvoiceDeficitCancel : RestfulExecution<Invoice>
    {

    }
}
